#define HTL 256
#define sk '\xBA'
#define ap '\xFA'   /* xFA on relatsiooni tryki "punkt":   */
#define MAX_FAILINIME_PIKKUS 256

  FILE *of;        /* w_bin & r_bin */
  FILE *rdf;       /* real data structures */
  int X;              /* 0 - Gx.grm,  1 - tri.grm  */
  char *Nimi;
  char rida[44];
  char word[20];      /* terminaalse vi mitteterminaalse thestiku tht */
  int def[20];       /* produktsiooni parem pool vahekeeles */

  int dl;             /* "def" pikkus */
  char sat[44];             /* ={"trigol.txt"};  */
  char *fname;        /*  grammatika teksti nimi (vib koos teega) */
  char RD[256];       /* Filename: Real Data Structures */
  char Rn[256];
  FILE *rules;        /* grammatikafaili handle */
  char *Buf;          /* sisendpuhver */
  int PF_length;      /* sisestatud teksti pikkus (Milam) */
  int P_length;       /* sisestatud teksti pikkus */
  char *GBuf;         /* sisendpuhver: grammar */
  int Glen;           /* sisestatud teksti pikkus: grammar */
  int Pnr;            /* produktsiooni jrk-nr */
  int olek;           /* automaadi jaoks */
  char *P;            /* sisendpuhvri jrg */
  char T[2*HTL][20];  /* thestiku V symbolite nimed */
  int left;
  int right;
  int V;
  int semflag;
  int *semantika;     /* semantikamassiiv */
  char *p_M;          /* puutrki indeksite vektor */
  int p_ML;           /* indeksite vektori pikkus */
  char *PM;           /* eelnevusmaatriks output */
  char Pm[HTL][HTL];  /* konstruktori eelnevusmaatriks */
  char Lm[HTL][HTL];  /* leftmost-maatriks */
  char Rm[HTL][HTL];  /* rightmost-maatriks */
  char *LC;           /* vasak sltumatu kontekst */
  char *RC;           /* parem sltumatu kontekst */
  int Index;          /* eelnevusteisenduste uute produktsioonide suffiks */
  int dep;            /* dep>0; analysaator kasutab BRC(1,1)-konteksti */
  int dc;    /* dc=0 kui sltuvat kontexti ei saa arvutada vi see ei eristu */
  int si;    /* stack index */
  char *DepV;         /* kui P[i]-l tegelik s6ltuv kontekst: DepV[i]=1 */

/* Produktsiooni parem pool */
struct R{
	int P;         /* produktsiooni jrk-nr */
	int sem;       /* semantikakood */
	int n;         /* NT definitsiooni pikkus */
	int *d;        /* NT definitsioon */
	struct R *alt; /* NT alternatiivne definitsioon */
	};

/* Thestiku V symboli (NT vi T) kirje */
struct D{
	int tunnus;  /* 0: NT, 1: T */
	int code;    /* vahekeelne kood */
	int L;       /* NT vi id/const nime pikkus  */
	int loc;     /* ident | const : nr */
	int icx;     /* itl vi ktl - IT vi KT index */
	struct D *left;   /* kahendpuu viidad (vti on s) */
	struct D *right;
	struct R *def;    /* NT: vahekeelne definitsioon */
	};

struct parm{
	int nr;
	int tnr;
	int BRC;
	int Pnr;
	int dep;
	int itl;
	int ktl;
};

/* Produktsioonide paremate poolte jrgi paisatud tabeli kirje */
struct h{
	int P;          /* produktsiooni jrk-nr */
	int n;          /* definitsiooni pikkus  */
	int NT;         /* defineeritav nonterminal  */
	int *d;        /* definitsioon */
	int nc;         /* 1 - sltuv kontekst */
	char *c;        /* reservis */
	struct h *same; /* sama parem pool */
	struct h *col;  /* prkeviit */
	};

  struct D *DT;     /* first   */
  struct D *DC;     /* current */
  struct D *DL;     /* last    */
  struct D *DN;     /* new     */

  int nr;     /* thestiku V jooksev pikkus */
  int tnr;    /* terminaalse thestiku jooksev pikkus */
  int ttl;    /* eraldajate arv */
  int NR;     /* eelnevusteisenduste 'uute produktsioonide' jooksev jrk-nr */
  int Sn;     /* 'nr' enne eelnevusteisendusi */
  int BRC;    /* hesuguste paremate pooltega produktsioonide arv */
  int context;  /* 0 kui G on pratav, 1 kui pole */
  struct parm *PARM;      /* parameetrid */
  struct h *hc;           /* BRC-analyysil detekteeritud kirje viit */
  struct h *HT[HTL];      /* hashtabel */
  struct h *prod[HTL];
  char ***DEP;	/* sltuv kontekst */
  FILE *Logi;
  char *L_name;
/* ------------------------------PARSER32-------------------------*/

#define idtl 50
#define ctl 50

#define MAX_ARRAY_LEN 1000

struct tri_array{
	int len;		/* massivi pikkus */
	int *data;		/* massivi sissend */
	};

/* identifikaatorite tabeli kirje */
struct itr{
	int nr;         /* jrk-nr thestikus V */
	int loc;
	int value;      /* interpretaator: muutuja vrtus */
	struct tri_array *arr;	/* interpretaaator: massiv */
	struct top *t;  /* kui id=mrgend: viit operaatorile */
	int io;         /* 0, kui pole, 1: read, 2: write, 3: r&w */
	};
	
/* konstantide tabeli kirje */
struct ctr{
	int nr;         /* jrk-nr thestikus V */
	int loc;
	int value;      /* konstandi vrtus */
	};



/* analyysipuu tipp */
struct top{
	int kood;          /* vahekeelne kood */
	int leks;          /* kui tipp=ident/const, siis selle jrk-nr. */
	int sem;           /* semantikakood */
	int label;         /* kui tipp on mrgendatud operaator - mrgendinr */
	int truel;         /* kompilaator: go to true */
	int falsel;        /* kompilaator: go to false */
	struct top *up;    /* puuviidad: les, */
	struct top *right; /* naabrile ja */
	struct top *down;  /* alluvale */
	};
	
  int KOOD;
  char *PBuf=NULL;     /* sisendpuhver: programm */
  int Plen=0;          /* sisestatud teksti pikkus: programm */
  char *gr_name;
  char *pr_name;
  char *Pr_name;      /* ilma laiendita */
  char TT[HTL][20];      /* pikkuse jrgi jrjestatud eraldajad VT-st */
  int vkl;                 /* VK pikkus */
  int *VK=NULL;           /* vahekeelne programm */
  int VEAD=0;              /* programmivigade loendaja */
  int VKL=0;               /* vahekeelse programmi symbolite arv */
  int bok;      /* tell_about(): 0 - ok, 1 - paha */
  int k_k;    /* konstandi vahekeelne kood */
  int m_k;    /* muutuja (identifikaatori) vahekeelne kood */
  int itl;    /* identifikaatorite tabeli index/pikkus */
  int ktl;    /* konstantide tabeli indeks/pikkus */
  int IT[50];     /* identifikaatorite tabel */
  int KT[50];     /* konstantide tabel */
  struct ctr *CT[ctl];
  struct top *t;   /* top of the parsing tree */
  struct itr *IDT[idtl];
  int logi=0;           /* kui 1, siis teeb kettale  xxx.log  */
  struct h *t_;
  int Stack[200];
  char rela[200];
  int lausevorm[20];
  struct top *puu[200];
  struct top *p_=NULL;     /*analsipuu tipp*/
  struct top *cp=NULL;
  int rel,I,J;
  int n_,l_,s_,N_,x_;
  int sem,marker;  
  int dummy;
  int flag;
  int Rd;
  int Wr;

  
void ExiT(char *t);
int constr(void);            /* constr.c */
void ctree(void);            /* constr.c */
void print_h(struct h *t);              /* hash.c */
int hfunc(int keylen,int *key);        /* hash.c */
struct h *ReadHash(int n,int *key);    /* hash.c */
int HashRule(struct D *t,struct R *r);  /* hash.c */
void HashNT(struct D *t);               /* hash.c */
void HashRules(struct D *t);            /* hash.c */
void print_L(struct h *CP);             /* hash.c */
void print_HT(void);                    /* hash.c */
void brc(int NT);                               /* indep.c */
void print_indepC(void);                        /* indep.c */
void print_cxt(char **L);                       /* dep.c */
void print_all_cxt(void);                       /* dep.c */
void print_all_cxtp(void);                      /* dep.c */
int g1(char **L,int X,int D);                   /* dep.c */
int g2(char **L,struct h *t,int X);             /* dep.c */
int g3(char **L,struct h *t,int D);             /* dep.c */
int g4(char **L,struct h *t);                   /* dep.c */
int search_springs(struct h *t,int A);          /* dep.c */
int test_dep_con(struct h *x,struct h *y);      /* dep.c */
int brctest(struct h *t);                       /* indep.c */
int make_BRC(void);                             /* indep.c */
void pT(int v);                                  /* dict.c */
struct D *newD(void);                           /* dict.c */
struct R *newR(void);                           /* dict.c */
void free_R(struct R *r);                       /* dict.c */
void free_tree(struct D *t);                    /* dict.c */
void printR(struct R *r);                       /* dict.c */
int print_rule(struct D *t,struct R *r);        /* dict.c */
int put_semant(void);                           /* sem.c */
struct D *search(int x);                        /* dict.c */ 
struct D *getV(char *key);                      /* dict.c */
void viga(int i);                               /* dict.c */
int p_viga(int i);                              /* scanner.c */
int print_rules(struct D *t);                   /* dict.c */
struct D *leftside(int l);                      /* dict.c */
void nonterm(int l);                            /* dict.c */
void term(int l,int flag);                      /* dict.c */
void makerul(void);                             /* dict.c */
int Terms(void);                                /* dict.c */
int Rules(void);                                /* dict.c */
void first_LR(struct D *t);                     /* lrm.c */
void sec_LR(int lrf,int nt);                    /* lrm.c */
void make_LRB(void);                            /* lrm.c */
void print_def(struct R *r);                    /* dict.c */
int relac(struct D *t);                         /* lrm.c */
int make_PM(void);                              /* lrm.c */
void print_rela(void);                          /* lrm.c */
void s_to_right(int lim, struct D *t,struct R *d);  /* conf.c */
void P2(int x,int y);                               /* conf.c */
void s_to_left(int lim, struct D *t,struct R *d);   /* conf.c */ 
void P1(int x,int y);                               /* conf.c */
void tell_conf(int p,int i,int j,int c);            /* conf.c */
int conflicts(void);                                /* conf.c */
void print_LRM(char M[HTL][HTL]);                   /* lrm.c */ 
void print_PM(void);       /* lrm.c */
void fprint_PM(void);      /* lrm.c */
int w_tabs(void);                      /* w_bin.c */

/* ----------------------PARSER32--------------------------------*/

char *jarray(char *pealkiri);
void ExIT(void);
char *gM(int p);                  /* w_bin.c */
struct top *r_ptree(void);        /* r_bin.c */
/* void set_up(struct top *root);     r_bin.c */
struct top *analyzer(void);       /* parser.c */
void print_VK(int k);      /* scanner.c */
int Ident(int k);          /* scanner.c */
int Const(int k);          /* scanner.c */
int scanner(void);         /* scanner.c */
int reduce(struct h *t,int x, int y);                         /* parser.c */
int p_stack(char *name,int *v,char *rel,int a,int n,int k);  /* parser.c */
struct top *newtop(int x,int i,int sem);                      /* parser.c */
void red_tree(struct top *puu[],struct top *p,int s,int n);   /* parser.c */
int pp2html(struct top *p);                    /* parser.c */
void sentential_form(void);                    /* parser.c */
int correct(void);                             /* parser.c */
struct top *parser(void);                      /* parser.c */
struct ctr *make_ctr(void);                    /* parser.c */
int make_CT(void);                             /* parser.c */
struct itr *make_itr(void);                    /* parser.c */
void free_CT(void);                            /* parser.c */
int make_IDT(void);                            /* parser.c */
void free_IDT(void);                           /* parser.c */
void p_itr(struct itr *id);                    /* parser.c */
void print_variables(void);                    /* parser.c */
void p_ctr(struct ctr *id);                    /* parser.c */
struct item *make_item(void);          /* interp.c */
void freestack(int i,int k);           /* interp.c */
void prist(int i,int ic);              /* interp.c */
int get_x(int i,int k);                /* interp.c */
void write_x(int x,int i);             /* interp.c */
void aritm(int i,int r);               /* interp.c */
void loogik(int i,int r);              /* interp.c */
int print_Op(struct top *t);           /* interp.c */
void p_prog(struct top *root);         /* interp.c */
void trigol_Int(struct top *root);     /* interp.c */
void prop(int s);                  /* parser.c */
void tprop(int s);                 /* parser.c */
FILE *opr(void);                     /* r_bin.c */
struct D *r_V(void);                 /* r_bin.c */
struct h *grec(void);                /* r_bin.c */
struct h *r_hr(void);                /* r_bin.c */
void r_HT(void);                     /* r_bin.c */
int r_tabs(void);                    /* r_bin.c */
void ctree(void);
void print_TREEK(void);
void print_data(int x,int y);
void print_mx(char *M,int x);
void print_sem(void);
void p_top(char *t,struct top *p);
void pf(const char *format,...);
void print_cxt(char **L);                       /* dep.c */
int itr(void);

/* -----------------------------------------------------------*/  